class TANListe {

	static final int ANZAHL_TANS = 100;

	int[] tans;
	boolean[] verbraucht;

	TANListe() {
		this.tans = new int[TANListe.ANZAHL_TANS];
		this.verbraucht = new boolean[TANListe.ANZAHL_TANS];
		this.tansGenerieren();
	}

	void print() {
		for (int i = 0; i < TANListe.ANZAHL_TANS; i++) {
			if (!this.verbraucht[i]) {
				System.out.print(this.tans[i] + " ");
			}
		}
		System.out.println();
	}

	boolean verbrauchen(int tan) {
		for (int i = 0; i < TANListe.ANZAHL_TANS; i++) {
			if (!this.verbraucht[i] && this.tans[i] == tan) {
				this.verbraucht[i] = true;
				return true;
			}
		}
		return false;
	}

	void tansGenerieren() {
		for (int i = 0; i < TANListe.ANZAHL_TANS; i++) {
			this.verbraucht[i] = false;
			this.tans[i] = TANListe.tanGenerien();
			while (this.existiert(this.tans[i], i)) {
				this.tans[i] = TANListe.tanGenerien();
			}
		}
	}

	boolean existiert(int tan, int bis) {
		for (int i = 0; i < bis; i++) {
			if (this.tans[i] == tan) {
				return true;
			}
		}
		return false;
	}

	// generiert 6-stellige TAN
	static int tanGenerien() {
		return (int) (Math.random() * 900000) + 100000;
	}
}

public class UE11Aufgabe8 {
	// kleines Testprogramm
	public static void main(String[] args) {
		TANListe liste = new TANListe();
		liste.print();
		while (true) {
			int nummer = IO.readInt("TAN eingeben: ");
			if (!liste.verbrauchen(nummer)) {
				break;
			}
			liste.print();
		}
	}
}
